#ifndef EXTRAPOLATION_TABLE_H
#define EXTRAPOLATION_TABLE_H

/**
 * @file ExtrapolationTable.h
 * @author Bryan BERTHOU (SPhN / CEA Saclay)
 * @date 22 January 2016
 * @version 1.0
 *
 * @class ExtrapolationTable
 *
 * @brief
 */

#include <stddef.h>
#include <vector>

class ExtrapolationTable {
public:

    ExtrapolationTable();
    virtual ~ExtrapolationTable();

    size_t m_n;
    std::vector<double> m_rlist2;
    size_t m_nres;
    std::vector<double> m_res3la;

    void append_table(double y);
    void qelg(double &result, double &abserr);
};

#endif /* EXTRAPOLATION_TABLE_H */
