#ifndef WORKSPACE_H
#define WORKSPACE_H

/**
 * @file Workspace.h
 * @author Bryan BERTHOU (SPhN / CEA Saclay)
 * @date 22 January 2016
 * @version 1.0
 */

#include <stddef.h>
#include <vector>

namespace NumA {

/**
 * @class Workspace
 *
 * @brief
 */


class Workspace {
public:
    size_t m_limit;
    size_t m_size;
    size_t m_nrmax;
    size_t m_i;
    size_t m_maximum_level;
    std::vector<double> m_alist;
    std::vector<double> m_blist;
    std::vector<double> m_rlist;
    std::vector<double> m_elist;
    std::vector<size_t> m_order;
    std::vector<size_t> m_level;

    Workspace(double limit);
    virtual ~Workspace();

    void initialise(double a, double b);

    void set_initial_result(double result, double error);

    void retrieve(double &a, double &b, double &r, double &e);

    void update(double a1, double b1, double area1, double error1, double a2,
            double b2, double area2, double error2);

    void qpsrt();

    int large_interval();

    int increase_nrmax();

    void reset_nrmax();

    double sum_results();
};

} // namespace NumA

#endif /* WORKSPACE_H */
