#ifndef VECTOR_4D_H
#define VECTOR_4D_H

/**
 * @file Vector4D.h
 * @author Bryan BERTHOU (SPhN / CEA Saclay)
 * @date 27 November 2014
 * @version 1.0
 */

#include "Vector3D.h"

//TODO mathematique function add, sub, ...

namespace NumA {

/**
 * @class Vector4D
 *
 * Object representing a four-vector.
 */
class Vector4D: public Vector3D {
public:
    /**
     * Default constructor.
     */
    Vector4D();
    /**
     * Constructor.
     * @param x x-coordinate.
     * @param y y-coordinate.
     * @param z z-coordinate.
     * @param e Energy/Time component.
     */
    Vector4D(double x, double y, double z, double e);
    /**
     * Default destructor.
     */
    ~Vector4D();

    // ##### GETTERS & SETTERS #####

    double getE() const; ///< Energy/Time component.
    void setE(double e); ///< Energy/Time component.

private:
    double m_e; ///< Energy/Time component.
};

} /* namespace NumA */

#endif /* VECTOR_4D_H */
