/*
 * NeuralNetworkNeuron.h
 *
 *  Created on: Apr 23, 2016
 *      Author: Pawel Sznajder
 */

#ifndef NEURALNETWORKNEURON_H_
#define NEURALNETWORKNEURON_H_

#include <string>

namespace NumA {

class NeuralNetworkCell;

class NeuralNetworkNeuron {

public:

    NeuralNetworkNeuron();
    NeuralNetworkNeuron(NeuralNetworkCell* const NeuralNetworkCellIn,
            NeuralNetworkCell* const NeuralNetworkCellOut);
    NeuralNetworkNeuron(const NeuralNetworkNeuron& other);
    virtual ~NeuralNetworkNeuron();
    virtual NeuralNetworkNeuron* clone() const;
    virtual std::string toString() const;

    double getWeight() const;
    void setWeight(double weight);

    void fixWeight();
    void releaseWeight();
    bool isWeightFixed() const;

    NeuralNetworkCell* getNeuralNetworkCellIn() const;
    void setNeuralNetworkCellIn(NeuralNetworkCell* cell);
    NeuralNetworkCell* getNeuralNetworkCellOut() const;
    void setNeuralNetworkCellOut(NeuralNetworkCell* cell);

private:

    double m_weight;
    bool m_fixedWeight;
    NeuralNetworkCell* m_neuralNetworkCellIn;
    NeuralNetworkCell* m_neuralNetwokCellOut;
};

}

#endif /* NEURALNETWORKNEURON_H_ */
