#ifndef MATH_UTILS_H
#define MATH_UTILS_H

/**
 * @file MathUtils.h
 * @author Bryan BERTHOU (SPhN / CEA Saclay)
 * @date February 17, 2016
 * @version 1.0
 */

namespace NumA {

/**
 * @class MathUtils
 *
 * @brief Miscellaneous utilities (mathematical functions, etc).
 */
class MathUtils {
public:
    /**
     * Degree-radian conversion.
     * @param degree Angle in degree.
     * @return Angle in radian.
     */
    static double convertDegreeToRadian(double degree);
    /**
     * DiLograrithm function.
     * @param x
     * @return \f$ Li_2\left(x\right) \f$.
     */
    static double DiLog(double x);
};

} /* namespace NumA */

#endif /* MATH_UTILS_H */
