#include "../../../../include/NumA/linear_algebra/eigen/EigenUtils.h"

namespace NumA {

Eigen::MatrixXd EigenUtils::convertToEigen(const MatrixD& A) {
    Eigen::MatrixXd EigenA(A.rows(), A.cols());
    for (unsigned int i = 0; i < A.rows(); i++) {
        for (unsigned int j = 0; j < A.cols(); j++) {
            EigenA(i, j) = A.at(i, j);
        }
    }
    return EigenA;
}

Eigen::VectorXd EigenUtils::convertToEigen(const VectorD& V) {
    Eigen::VectorXd EigenV(V.size());
    for (unsigned int i = 0; i < V.size(); i++) {
        EigenV(i) = V.at(i);
    }
    return EigenV;
}

VectorD EigenUtils::convertToVectorD(const Eigen::VectorXd& EigenV) {
    VectorD V(EigenV.size());
    for (unsigned int i = 0; i < V.size(); i++) {
        V.at(i) = EigenV(i);
    }
    return V;
}

} /* namespace NumA */
