/*
 * MatrixComplex2D.cpp
 *
 *  Created on: Jan 16, 2016
 *      Author: Pawel Sznajder (IPNO)
 */

#include "../../../../include/NumA/linear_algebra/matrix_complex/MatrixComplex2D.h"

#include <stdexcept>

namespace NumA {

MatrixComplex2D::MatrixComplex2D() :
        MatrixComplexD(2, 2) {
}

MatrixComplex2D::MatrixComplex2D(const MatrixComplex2D& v) :
        MatrixComplexD(v) {
}

MatrixComplex2D::MatrixComplex2D(const MatrixComplexD& v) :
        MatrixComplexD(v) {

    if (v.GetNElements(X) != 2 && v.GetNElements(Y) != 2)
        throw std::runtime_error(
                "MatrixComplex2D::MatrixComplex2D(): Can not copy from matrix of dimension different then 2x2");
}

MatrixComplex2D::~MatrixComplex2D() {
}

void MatrixComplex2D::operator =(const MatrixComplex2D& rhs) {
    this->MatrixComplexD::operator =(rhs);
}

MatrixComplex2D MatrixComplex2D::operator +(const MatrixComplex2D& rhs) {
    return MatrixComplex2D(this->MatrixComplexD::operator +(rhs));
}

MatrixComplex2D MatrixComplex2D::operator -(const MatrixComplex2D& rhs) {
    return MatrixComplex2D(this->MatrixComplexD::operator -(rhs));
}

MatrixComplex2D MatrixComplex2D::operator *(const double& rhs) {
    return MatrixComplex2D(this->MatrixComplexD::operator *(rhs));
}

MatrixComplex2D operator *(const double& lhs, MatrixComplex2D& rhs) {
    return rhs * lhs;
}

MatrixComplex2D MatrixComplex2D::operator *(const std::complex<double>& rhs) {
    return MatrixComplex2D(this->MatrixComplexD::operator *(rhs));
}

MatrixComplex2D operator *(const std::complex<double>& lhs,
        MatrixComplex2D& rhs) {
    return rhs * lhs;
}

} /* namespace NumA */
