/*
 * VectorComplex2D.cpp
 *
 *  Created on: Jan 16, 2016
 *      Author: Pawel Sznajder (IPNO)
 */

#include "../../../../include/NumA/linear_algebra/vector_complex/VectorComplex2D.h"

#include <stdexcept>

namespace NumA {

VectorComplex2D::VectorComplex2D() :
        VectorComplexD(2) {
}

VectorComplex2D::VectorComplex2D(const VectorComplex2D& v) :
        VectorComplexD(v) {
}

VectorComplex2D::VectorComplex2D(const VectorComplexD& v) :
        VectorComplexD(v) {

    if (v.GetNElements() != 2)
        throw std::runtime_error(
                "VectorComplex2D::VectorComplex2D(): Can not copy from vector of dimension different then 2");
}

VectorComplex2D::~VectorComplex2D() {
}

void VectorComplex2D::operator =(const VectorComplex2D& rhs) {
    this->VectorComplexD::operator =(rhs);
}

VectorComplex2D VectorComplex2D::operator +(const VectorComplex2D& rhs) {
    return VectorComplex2D(this->VectorComplexD::operator +(rhs));
}

VectorComplex2D VectorComplex2D::operator -(const VectorComplex2D& rhs) {
    return VectorComplex2D(this->VectorComplexD::operator -(rhs));
}

VectorComplex2D VectorComplex2D::operator *(const double& rhs) {
    return VectorComplex2D(this->VectorComplexD::operator *(rhs));
}

VectorComplex2D operator *(const double& lhs, VectorComplex2D& rhs) {
    return rhs * lhs;
}

VectorComplex2D VectorComplex2D::operator *(const std::complex<double>& rhs) {
    return VectorComplex2D(this->VectorComplexD::operator *(rhs));
}

VectorComplex2D operator *(const std::complex<double>& lhs,
        VectorComplex2D& rhs) {
    return rhs * lhs;
}

}
