/*
 * VectorComplex3D.cpp
 *
 *  Created on: Jan 16, 2016
 *      Author: Pawel Sznajder (IPNO)
 */

#include "../../../../include/NumA/linear_algebra/vector_complex/VectorComplex3D.h"

#include <stdexcept>

namespace NumA {

VectorComplex3D::VectorComplex3D() :
        VectorComplexD(3) {
}

VectorComplex3D::VectorComplex3D(const VectorComplex3D& v) :
        VectorComplexD(v) {
}

VectorComplex3D::VectorComplex3D(const VectorComplexD& v) :
        VectorComplexD(v) {

    if (v.GetNElements() != 3)
        throw std::runtime_error(
                "VectorComplex3D::VectorComplex3D(): Can not copy from vector of dimension different then 3");
}

VectorComplex3D::~VectorComplex3D() {
}

void VectorComplex3D::operator =(const VectorComplex3D& rhs) {
    this->VectorComplexD::operator =(rhs);
}

VectorComplex3D VectorComplex3D::operator +(const VectorComplex3D& rhs) {
    return VectorComplex3D(this->VectorComplexD::operator +(rhs));
}

VectorComplex3D VectorComplex3D::operator -(const VectorComplex3D& rhs) {
    return VectorComplex3D(this->VectorComplexD::operator -(rhs));
}

VectorComplex3D VectorComplex3D::operator *(const double& rhs) {
    return VectorComplex3D(this->VectorComplexD::operator *(rhs));
}

VectorComplex3D operator *(const double& lhs, VectorComplex3D& rhs) {
    return rhs * lhs;
}

VectorComplex3D VectorComplex3D::operator *(const std::complex<double>& rhs) {
    return VectorComplex3D(this->VectorComplexD::operator *(rhs));
}

VectorComplex3D operator *(const std::complex<double>& lhs,
        VectorComplex3D& rhs) {
    return rhs * lhs;
}

}
