/*
 * VectorComplex4D.cpp
 *
 *  Created on: Jan 16, 2016
 *      Author: Pawel Sznajder (IPNO)
 */

#include "../../../../include/NumA/linear_algebra/vector_complex/VectorComplex4D.h"

#include <stdexcept>

namespace NumA {

VectorComplex4D::VectorComplex4D() :
        VectorComplexD(4) {
}

VectorComplex4D::VectorComplex4D(const VectorComplex4D& v) :
        VectorComplexD(v) {
}

VectorComplex4D::VectorComplex4D(const VectorComplexD& v) :
        VectorComplexD(v) {

    if (v.GetNElements() != 4)
        throw std::runtime_error(
                "VectorComplex4D::VectorComplex4D(): Can not copy from vector of dimension different then 4");
}

VectorComplex4D::~VectorComplex4D() {
}

void VectorComplex4D::operator =(const VectorComplex4D& rhs) {
    this->VectorComplexD::operator =(rhs);
}

VectorComplex4D VectorComplex4D::operator +(const VectorComplex4D& rhs) {
    return VectorComplex4D(this->VectorComplexD::operator +(rhs));
}

VectorComplex4D VectorComplex4D::operator -(const VectorComplex4D& rhs) {
    return VectorComplex4D(this->VectorComplexD::operator -(rhs));
}

VectorComplex4D VectorComplex4D::operator *(const double& rhs) {
    return VectorComplex4D(this->VectorComplexD::operator *(rhs));
}

VectorComplex4D operator *(const double& lhs, VectorComplex4D& rhs) {
    return rhs * lhs;
}

VectorComplex4D VectorComplex4D::operator *(const std::complex<double>& rhs) {
    return VectorComplex4D(this->VectorComplexD::operator *(rhs));
}

VectorComplex4D operator *(const std::complex<double>& lhs,
        VectorComplex4D& rhs) {
    return rhs * lhs;
}

}
