/*
 * CombinationFunctionType.cpp
 *
 *  Created on: Apr 24, 2016
 *      Author: Pawel Sznajder
 */

#include "../../../../include/NumA/neural_network/beans/CombinationFunctionType.h"

namespace NumA {

CombinationFunctionType::CombinationFunctionType() {
    m_type = CombinationFunctionType::UNDEFINED;
}

CombinationFunctionType::CombinationFunctionType(
        CombinationFunctionType::Type type) {
    m_type = type;
}

CombinationFunctionType::CombinationFunctionType(
        const CombinationFunctionType& other) {
    m_type = other.m_type;
}

CombinationFunctionType::~CombinationFunctionType() {
}

CombinationFunctionType* CombinationFunctionType::clone() const {
    return new CombinationFunctionType(*this);
}

std::string CombinationFunctionType::toString() const {

    switch (m_type) {

    case CombinationFunctionType::UNDEFINED: {
        return "UNDEFINED";
    }

        break;

    case CombinationFunctionType::ScalarProduct: {
        return "ScalarProduct";
    }

        break;

    default: {
        return "UNDEFINED";
    }

        break;
    }
}

}

